/*
 * Copyright (c) IntellectualCrafters - 2014. You are not allowed to distribute
 * and/or monetize any of our intellectual property. IntellectualCrafters is not
 * affiliated with Mojang AB. Minecraft is a trademark of Mojang AB.
 * 
 * >> File = Helpers.java >> Generated by: Citymonstret at 2014-08-09 01:41
 */

package com.intellectualcrafters.plot.commands;

import java.util.UUID;

import org.bukkit.Bukkit;
import org.bukkit.entity.Player;

import com.intellectualcrafters.plot.C;
import com.intellectualcrafters.plot.PlayerFunctions;
import com.intellectualcrafters.plot.Plot;
import com.intellectualcrafters.plot.UUIDHandler;
import com.intellectualcrafters.plot.database.DBFunc;
import com.intellectualcrafters.plot.events.PlayerPlotHelperEvent;

@SuppressWarnings("deprecation")
public class Helpers extends SubCommand {

	public Helpers() {
		super(Command.HELPERS, "Manage plot helpers", "helpers {add|remove} {player}", CommandCategory.ACTIONS, true);
	}

	@Override
	public boolean execute(Player plr, String... args) {
		if (args.length < 2) {
			PlayerFunctions.sendMessage(plr, C.HELPER_NEED_ARGUMENT);
			return true;
		}
		if (!PlayerFunctions.isInPlot(plr)) {
			PlayerFunctions.sendMessage(plr, C.NOT_IN_PLOT);
			return true;
		}
		Plot plot = PlayerFunctions.getCurrentPlot(plr);
		if ((plot.owner == null) || !plot.hasRights(plr)) {
			PlayerFunctions.sendMessage(plr, C.NO_PLOT_PERMS);
			return true;
		}
		if (args[0].equalsIgnoreCase("add")) {
		    UUID uuid;
			if (args[1].equalsIgnoreCase("*")) {
				uuid = DBFunc.everyone;
			}
			else {
			    uuid = UUIDHandler.getUUID(args[1]);
			}
			if (!plot.helpers.contains(uuid)) {
                if (plot.owner == uuid) {
                    PlayerFunctions.sendMessage(plr, C.ALREADY_OWNER);
                    return false;
                }
                if (plot.trusted.contains(uuid)) {
                    plot.trusted.remove(uuid);
                    DBFunc.removeTrusted(plr.getWorld().getName(), plot, Bukkit.getOfflinePlayer(uuid));
                }
                if (plot.denied.contains(uuid)) {
                    plot.denied.remove(uuid);
                    DBFunc.removeDenied(plr.getWorld().getName(), plot, Bukkit.getOfflinePlayer(uuid));
                }
                plot.addHelper(uuid);
                DBFunc.setHelper(plr.getWorld().getName(), plot, Bukkit.getOfflinePlayer(args[1]));
                PlayerPlotHelperEvent event = new PlayerPlotHelperEvent(plr, plot, uuid, true);
                Bukkit.getPluginManager().callEvent(event);
            }
            else {
                PlayerFunctions.sendMessage(plr, C.ALREADY_ADDED);
                return false;
            }
            PlayerFunctions.sendMessage(plr, C.HELPER_ADDED);
            return true;
		}
		else
			if (args[0].equalsIgnoreCase("remove")) {
				if (args[1].equalsIgnoreCase("*")) {
					UUID uuid = DBFunc.everyone;
					if (!plot.helpers.contains(uuid)) {
						PlayerFunctions.sendMessage(plr, C.WAS_NOT_ADDED);
						return true;
					}
					plot.removeHelper(uuid);
					DBFunc.removeHelper(plr.getWorld().getName(), plot, Bukkit.getOfflinePlayer(args[1]));
					PlayerFunctions.sendMessage(plr, C.HELPER_REMOVED);
					return true;
				}
				/*
				 * if (!hasBeenOnServer(args[1])) {
				 * PlayerFunctions.sendMessage(plr, C.PLAYER_HAS_NOT_BEEN_ON);
				 * return true; } UUID uuid = null; if
				 * (Bukkit.getPlayer(args[1]) != null) { uuid =
				 * Bukkit.getPlayer(args[1]).getUniqueId(); } else { uuid =
				 * Bukkit.getOfflinePlayer(args[1]).getUniqueId(); } if (uuid ==
				 * null) { PlayerFunctions.sendMessage(plr,
				 * C.PLAYER_HAS_NOT_BEEN_ON); return true; } if
				 * (!plot.helpers.contains(uuid)) {
				 * PlayerFunctions.sendMessage(plr, C.WAS_NOT_ADDED); return
				 * true; }
				 */
				UUID uuid = UUIDHandler.getUUID(args[1]);
				plot.removeHelper(uuid);
				DBFunc.removeHelper(plr.getWorld().getName(), plot, Bukkit.getOfflinePlayer(args[1]));
				PlayerPlotHelperEvent event = new PlayerPlotHelperEvent(plr, plot, uuid, false);
				Bukkit.getPluginManager().callEvent(event);
				PlayerFunctions.sendMessage(plr, C.HELPER_REMOVED);
			}
			else {
				PlayerFunctions.sendMessage(plr, C.HELPER_NEED_ARGUMENT);
				return true;
			}
		return true;
	}
}
